/**
 * @fileoverview 첽ļϴ
 * @author ƽӣ<minghe36@126.com>,Ӣ<daxingplay@gmail.com>
 **/
KISSY.add(function(S, Base, Node, UrlsInput, IframeType, AjaxType) {
    var EMPTY = '',$ = Node.all,LOG_PREFIX = '[uploader]:';

    /**
     * @name Uploader
     * @class 첽ļϴĿǰʹajax+iframeķպflash
     * @constructor
     * @extends Base
     * @requires Node,UrlsInput,IframeType,AjaxType
     */
    function Uploader(config) {
        var self = this;
        //ø๹캯
        Uploader.superclass.constructor.call(self, config);
    }

    S.mix(Uploader, /** @lends Uploader*/{
        /**
         * ϴʽ
         */
        type : {AUTO : 'auto',IFRAME : 'iframe',AJAX : 'ajax'},
        /**
         * ¼
         */
        event : {
            //
            RENDER : 'render',
            //ѡļ󴥷
            SELECT : 'select',
            //ʼϴ
            START : 'start',
            // ϴ
            UPLOADING: 'uploading',
            //ϴɣϴɹϴʧܺ󶼻ᴥ
            COMPLETE :'complete',
            //ϴɹ
            SUCCESS : 'success',
            //ϴʧ
            ERROR : 'error'
        }
    });
    //̳BasegettersetterίBase
    S.extend(Uploader, Base, /** @lends Uploader.prototype*/{
        /**
         * 
         * @return {Uploader}
         */
        render : function() {
            var self = this,serverConfig = self.get('serverConfig'),
                UploadType = self.getUploadType(),uploadType;
            if (!UploadType) return false;
            //·inputʵ
            self.set('urlsInput',self._renderUrlsInput());
            self._renderQueue();
            self._renderButton();
            uploadType = new UploadType(serverConfig);
            //ϴϴ¼
            uploadType.on(uploadType.constructor.event.SUCCESS, self._uploadCompleteHanlder, self);
            //ϴϴֹͣ¼
            uploadType.on(uploadType.constructor.event.STOP, self._uploadStopHanlder, self);
            self.set('uploadType', uploadType);
            self.fire(Uploader.event.RENDER);
            return self;
        },
        /**
         * ϴļ
         * @param {Number} fileId ļֵ
         */
        upload : function(fileId) {
            if (!S.isNumber(fileId)) return false;
            var self = this,uploadType = self.get('uploadType'),
                queue = self.get('queue'),
                file = queue.get('files')[fileId],
                fileInput;
            if (!S.isPlainObject(file)) {
                S.log(LOG_PREFIX + 'вidΪ' + fileId + 'ļ');
                return false;
            }
            //ļϴ
            fileInput = file.input;
            //ļϴǰ¼
            self.fire(Uploader.event.START, {id : fileId,file : file});
            //õǰϴļid
            self.set('curUploadId', fileId);
            //ıļϴ״̬Ϊstart
            queue.fileStatus(fileId, queue.constructor.status.START);
            //ʼϴ
            uploadType.upload(fileInput);
        },
        /**
         * ȡϴ
         */
        cancel : function(){
            var self = this,uploadType = self.get('uploadType');
            uploadType.stop();
        },
        /**
         * Ƿ֧ajaxϴ
         * @return {Boolean}
         */
        isSupportAjax : function() {
            return S.isObject(FormData);
        },
        /**
         * ȡϴʽࣨiframeajax
         * @return {IframeType|AjaxType}
         */
        getUploadType : function() {
            var self = this,type = self.get('type'),types = Uploader.type,
                isSupportAjax = self.isSupportAjax(),UploadType;
            switch (type) {
                case types.AUTO :
                    UploadType = isSupportAjax && AjaxType || IframeType;
                    break;
                case types.IFRAME :
                    UploadType = IframeType;
                    break;
                case types.AJAX :
                    UploadType = AjaxType;
                    break;
                default :
                    S.log(LOG_PREFIX + 'typeϷֵֻΪ' + types.AUTO + ',' + types.IFRAME + ',' + types.AJAX);
                    return false;
            }
            return UploadType;
        },
        /**
         * Buttonϴť
         * @return {Button}
         */
        _renderButton : function() {
            var self = this,button = self.get('button');
            if (!S.isObject(button)) {
                S.log(LOG_PREFIX + 'buttonϷ');
                return false;
            }
            //ťı¼
            button.on('change', self._select, self);
            //аťʵ
            button.render();
            return button;
        },
        /**
         * Queue
         * @return {Queue} ʵ
         */
        _renderQueue : function() {
            var self = this,queue = self.get('queue'),
                urlsInput = self.get('urlsInput');
            if (!S.isObject(queue)) {
                S.log(LOG_PREFIX + 'queueϷ');
                return false;
            }
            //еɾ¼
            queue.on(queue.constructor.event.REMOVE,function(ev){
                urlsInput.remove(ev.id);
            });
            queue.render();
            return queue;
        },
        /**
         * ѡļ
         */
        _select : function(ev) {
            var self = this,autoUpload = self.get('autoUpload'),
                queue = self.get('queue'),
                //ev.filesΪļֵı䴥صļ飬Ĭ飬ڲֶ֧ѡֻҪȡһļ
                file = ev.files[0],
                oFile = {name : ev.name,input : ev.input,file : file},
                fileId;
            self.fire(Uploader.event.SELECT);
            //ļ
            fileId = queue.add(oFile);
            autoUpload && self.upload(fileId);
        },
        /**
         * ϴťڴ洢ļ·input
         */
        _renderUrlsInput : function() {
            var self = this,button = self.get('button'),inputWrapper = button.target,
                name = self.get('urlsInputName'),
                urlsInput = new UrlsInput(inputWrapper, {name : name});
            urlsInput.render();
            return urlsInput;
        },
        /**
         * ϴϺ󷵻ؽĴ
         */
        _uploadCompleteHanlder : function(ev) {
            var self = this,result = ev.result,status,event = Uploader.event,
                queue = self.get('queue'),id = self.get('curUploadId'),
                file = queue.getFile(id);
            if (!S.isObject(result)) return false;
            //ļϴ״̬
            status = result.status;
            if (status) {
                //޸Ķļ״̬Ϊsuccessϴɣ
                queue.fileStatus(id, queue.constructor.status.SUCCESS);
                self._success(result.data);
                self.fire(event.SUCCESS);
            } else {
                //޸Ķļ״̬Ϊerrorϴʧܣ
                queue.fileStatus(id, queue.constructor.status.ERROR);
                self.fire(event.ERROR, {status : status});
            }
            //ÿյǰϴid
            self.set('curUploadId', EMPTY);
            self.fire(event.COMPLETE);
        },
        /**
         * ȡϴõķ
         */
        _uploadStopHanlder : function(){
            var self = this,queue = self.get('queue'),
                id = self.get('curUploadId');
            queue.fileStatus(id, queue.constructor.status.CANCEL);
        },
        _success : function(data){
            if(!S.isObject(data)) return false;
            var self = this,url = data.url,
                urlsInput = self.get('urlsInput'),
                fileId = self.get('curUploadId');
            if(!S.isString(url) || !S.isObject(urlsInput)) return false;
            //··
            urlsInput.add(fileId,url);
        },
        _error : function(){

        }

    }, {ATTRS : /** @lends Uploader*/{
        /**
         * Buttonťʵ
         */
        button : {value : {}},
        /**
         * Queueеʵ
         */
        queue : {value : {}},
        /**
         * õϴautoԶѡiframeiframeajaxajax
         */
        type : {value : Uploader.type.AUTO},
        /**
         * 
         */
        serverConfig : {value : {action : EMPTY,data : {},dataType : 'json'}},
        /**
         * Ƿϴļ
         */
        isAllowUpload : {value : true},
        /**
         * ǷԶϴ
         */
        autoUpload : {value : true},
        /**
         * 洢ļ·name
         */
        urlsInputName : {value : EMPTY},
        //ǰϴid
        curUploadId : {value : EMPTY},
        uploadType : {value : {}},
        urlsInput : {value : EMPTY}
    }});
    return Uploader;
}, {requires:['base','node','./urlsInput','./type/iframe','./type/ajax']});