/**
 * @fileoverview ļϴ
 * @author ƽӣ<minghe36@126.com>,Ӣ<daxingplay@gmail.com>
 **/
KISSY.add(function(S, Base, Node, Uploader, Button, Queue) {
    var EMPTY = '',$ = Node.all,LOG_PREFIX = '[uploaderRender]:';

    /**
     * ҳdata-configΪ
     * @param {String} hook 
     * @param {String} dataConfigName 
     * @return {Object}
     */
    function parseConfig(hook, dataConfigName) {
        var config = {},sConfig,DATA_CONFIG = dataConfigName || 'data-config';
        sConfig = $(hook).attr(DATA_CONFIG);
        if (!S.isString(sConfig)) return {};
        try {
            config = JSON.parse(sConfig);
        } catch(err) {
            S.log(LOG_PREFIX + '' + hook + '' + DATA_CONFIG + 'ڵjsonʽǷϹ淶');
        }
        return config;
    }

    /**
     * @name RenderUploader
     * @class ļϴ
     * @constructor
     * @param {String | HTMLElement} buttonTarget ϴťĿԪ
     * @param {String | HTMLElement} queueTarget ļĿԪ
     * @param {Object} config 
     */
    function RenderUploader(buttonTarget, queueTarget, config) {
        var self = this;
        config = config || parseConfig(buttonTarget);
        //ʼ
        RenderUploader.superclass.constructor.call(self, config);
        self.set('buttonTarget', buttonTarget);
        self.set('queueTarget', queueTarget);
        self.set('uploaderConfig', config);
        self._init();
    }

    S.extend(RenderUploader, Base, {
        /**
         * ʼ
         */
        _init : function() {
            var self = this,uploaderConfig = self.get('uploaderConfig'),
                button = self._initButton(),
                queue = self._initQueue();
            self.set('button', button);
            self.set('queue', queue);
            //ӰťʵͶʵ
            S.mix(uploaderConfig, {button : button,queue : queue});
            var uploader = new Uploader(uploaderConfig);
            uploader.render();
        },
        /**
         * ʼģϴť
         * @return {Button}
         */
        _initButton : function() {
            var self = this,target = self.get('buttonTarget'),name = self.get('name');
            //ʵϴť
            return new Button(target, {name : name});
        },
        /**
         * ʼϴļ
         * @return {Queue}
         */
        _initQueue : function() {
            var self = this,target = self.get('queueTarget');
            return new Queue(target);
        }
    }, {
        ATTRS : {
            /**
             * ťĿԪ
             */
            buttonTarget : {value : EMPTY},
            /**
             * ĿԪ
             */
            queueTarget : {value : EMPTY},
            /**
             * ϴ
             */
            uploaderConfig : {},
            /**
             * Buttonϴťʵ
             */
            button : {value : EMPTY},
            /**
             * QueueϴУʵ
             */
            queue : {value : EMPTY}
        }
    });
    return RenderUploader;
}, {requires:['base','node','./base','./button/base','./queue/base']});